/***********************************************
* conf.c - Read in the configuration file
* 
* CVS $Id: conf.c,v 1.8 2000/06/27 12:44:16 wcampbel Exp $
***********************************************/

#include "split.h"

void strip(char *line)
{
	char *c;

	if ((c = strchr(line, '\n')))	*c = '\0';
	if ((c = strchr(line, '\r')))	*c = '\0';
}

void LoadConf()
{
	FILE *fp;
	char buf[BUFSIZE];
	char *s;

	if ((fp = fopen(CONFFILE, "r")) == NULL) {
		printf("Unable to open configuration file (%s)\n", CONFFILE);
		exit(0);
	}


	while (fgets(buf, BUFSIZE, fp)) {
		if (buf[0] == '#') {
			continue;
		}
		s = strtok(buf, " ");
		if (!strcmp(s, "SERVER_NAME")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.name, s, sizeof(me.name));
		} else if (!strcmp(s, "SERVER_PORT")) {
			s = strtok(NULL, "\n");
			me.port = atoi(s);
		} else if (!strcmp(s, "CONNECT_TO")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.uplink, s, sizeof(me.uplink));
		} else if (!strcmp(s, "CONNECT_PASS")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.pass, s, sizeof(me.pass));
		} else if (!strcmp(s, "SERVER_DESC")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.desc, s, sizeof(me.desc));
		} else if (!strcmp(s, "RECONNECT_TIME")) {
			s = strtok(NULL, "\n");
			me.r_time = atoi(s);
		} else if (!strcmp(s, "DELAY")) {
			s = strtok(NULL, "\n");
			me.delay = atoi(s);
		} else if (!strcmp(s, "SPLITSERV_HOST")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(SplitServ.host, s, sizeof(SplitServ.host));
		} else if (!strcmp(s, "SPLITSERV_USER")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(SplitServ.user, s, sizeof(SplitServ.user));
		} else if (!strcmp(s, "SPLITSERV_NICK")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(SplitServ.nick, s, sizeof(SplitServ.nick));
		} else if (!strcmp(s, "CHANNEL")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.join_chan, s, sizeof(me.join_chan));
		} else if (!strcmp(s, "ADMINPASS")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.adpass, s, sizeof(me.adpass));
		}
	}
	fclose(fp);
}

