/**************************************************************
* SplitServ main header file
* $Id: split.h,v 1.20 2000/06/27 13:22:17 wcampbel Exp $
**************************************************************/

#ifndef SPLIT_H
#define SPLIT_H

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <netdb.h>
#include <netinet/in.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <sys/time.h>
#include <ctype.h>
#include <sys/stat.h>
#include "config.h"

#define BUFSIZE 512
#define MAXSERVER 64
#define bzero(x,y)	memset(x, '\0', y);
#define MAXNICK	32
#define MAXUSER	10
#define MAXHOST	63
#define MAXPASS	32
#define MAXDEPTH 15
#define LINE 80

typedef struct server_ Server;

struct server_ {
	char* name;
	Server* uplink;
	int numleaf;
	Server* leaflist[MAXSERVER];
};

struct me {
	char uplink[MAXHOST];
	char name[MAXHOST];
	int port;
	char desc[LINE];
	int r_time;
	char pass[MAXPASS];
	char adpass[MAXPASS];
	char version[LINE];
	int privmsg;
	int numserver;
	char join_chan[LINE];
	int delay;
} me;

struct SplitServ {
	char host[MAXHOST];
	char user[MAXUSER];
	char nick[MAXNICK];
} SplitServ;

int servsock;
time_t notice;
int is_delayed;
Server* split_table[MAXSERVER];
Server* server_table[MAXSERVER];
Server* map_head;

/* conf.c */
extern void strip(char *);
extern void LoadConf();

/* sock.c */
extern void ListenLoop();
extern int Connect();

/* irc.c */
extern void Register();
extern void InitSplitServ();
extern void Parse(char *);
extern void PrintSplit(char *);
extern void PrintMap(char *, Server *, int);
extern void PrintDump(char *);
extern char* dash(int);
extern void Shutdown(char *, char *);
extern void Restart(char *, char *);
extern void PrintHelp(char *, char *);

/* util.c */
extern void log(char *, ...);
extern void sts(char *, ...);

/* timer.c */
extern void chk();
extern void TimerMidnight();
extern int is_midnight();

/* data.c */
extern Server* NewServer(char *, char *);
extern Server* FindServer(char *);
extern void DelServer(char *);
extern void NewSplit(char *);
extern void DelSplit(char *);

#endif
